# org.pdfclown.documents.files.FullFileSpecification Class Reference

Extended reference to the contents of another file [PDF:1.6:3.10.2]. More...

Inheritance diagram for org.pdfclown.documents.files.FullFileSpecification:

List of all members.

## Public Types
enum | StandardFileSystemEnum { Native, URL }
| Standard file system. More...
## Public Member Functions
virtual object | Clone (Document context)
| Gets a clone of the object, registered inside the given document context.
virtual bool | Delete ()
| Removes the object from its document context.
override bool | Equals (object obj)
string | GetAbsolutePath ()
| Gets the file absolute path.
override int | GetHashCode ()
override bytes::IInputStream | GetInputStream ()
| Gets an input stream to read from the file.
override bytes::IOutputStream | GetOutputStream ()
| Gets an output stream to write into the file.
void | SetPath (string value)
## Static Public Member Functions
static FullFileSpecification | Get (Document context, Uri url)
| Creates a new reference to a remote file.
static FullFileSpecification | Get (EmbeddedFile embeddedFile, string filename)
| Creates a new reference to an embedded file.
static FileSpecification | Get (Document context, string path, bool full)
| Creates a new reference to a file.
static SimpleFileSpecification | Get (Document context, string path)
| Creates a new reference to an external file.
static PdfDirectObject | GetBaseObject (PdfObjectWrapper wrapper)
| Gets the PDF object backing the specified wrapper.
static FileSpecification | Wrap (PdfDirectObject baseObject)
| Instantiates an existing file reference.
## Protected Member Functions
void | CheckCompatibility (object feature)
| Checks whether the specified feature is compatible with the document's conformance version.
virtual PdfString | RetrieveName ()
| Retrieves the name possibly associated to this object, walking through the document's name dictionary.
PdfDirectObject | RetrieveNamedBaseObject ()
| Retrieves the object name, if available; otherwise, behaves like PdfObjectWrapper.BaseObject.
## Properties
PdfDirectObject | BaseObject`[get]`
| Gets the underlying reference object, if available; otherwise, gets the underlying data object.
virtual PdfDirectObject | BaseObject`[get, set]`
PdfIndirectObject | Container`[get]`
| Gets the indirect object containing the base object.
PdfIndirectObject | DataContainer`[get]`
| Gets the indirect object containing the base data object.
RelatedFiles | Dependencies`[get, set]`
| Gets/Sets the related files.
string | Description`[get, set]`
| Gets/Sets the description of the file.
Document | Document`[get]`
| Gets the document context.
EmbeddedFile | EmbeddedFile`[get, set]`
| Gets/Sets the embedded file corresponding to this file.
File | File`[get]`
| Gets the file context.
object | FileSystem`[get, set]`
| Gets/Sets the file system to be used to interpret this file specification.
FileIdentifier | ID`[get, set]`
| Gets/Sets the identifier of the file.
PdfString | Name`[get]`
| Gets the object name.
PdfDirectObject | NamedBaseObject`[get]`
| Gets the object name, if available; otherwise, behaves like BaseObject.
override string | Path`[get]`
| Gets the file path.
bool | Volatile`[get, set]`
| Gets/Sets whether the referenced file is volatile (changes frequently with time).

##

Extended reference to the contents of another file [PDF:1.6:3.10.2].

## Member Enumeration Documentation

enum org::pdfclown::documents::files::FullFileSpecification::StandardFileSystemEnum

Standard file system.

Enumerator:

  Native | Generic platform file system.
  URL | Uniform resource locator.

## Member Function Documentation

void org.pdfclown.objects.PdfObjectWrapper.CheckCompatibility | ( | object | feature | ) | `[protected, inherited]`

Checks whether the specified feature is compatible with the document's conformance version.

Parameters:

  | feature | Entity whose compatibility has to be checked. Supported types: VersionEnum Property name resolvable to an annotated getter method MemberInfo

virtual object org.pdfclown.objects.PdfObjectWrapper.Clone | ( | Document | context | ) | `[virtual, inherited]`

Gets a clone of the object, registered inside the given document context.

Parameters:

  | context | Which document the clone has to be registered in.

virtual bool org.pdfclown.objects.PdfObjectWrapper.Delete | ( |  | ) | `[virtual, inherited]`

Removes the object from its document context.

The object is no more usable after this method returns.

Returns:
  Whether the object was actually decontextualized (only indirect objects can be decontextualize).

override bool org.pdfclown.objects.PdfObjectWrapper.Equals | ( | object | obj | ) | `[inherited]`

static FullFileSpecification org.pdfclown.documents.files.FileSpecification.Get | ( | Document | context,
|  | Uri | url |
| ) |  |  | `[static, inherited]`

Creates a new reference to a remote file.

Parameters:

  | context | Document context.
  | url | Remote file location.

static FullFileSpecification org.pdfclown.documents.files.FileSpecification.Get | ( | EmbeddedFile | embeddedFile,
|  | string | filename |
| ) |  |  | `[static, inherited]`

Creates a new reference to an embedded file.

Parameters:

  | embeddedFile | Embedded file corresponding to the reference.
  | filename | Name corresponding to the reference.

static FileSpecification org.pdfclown.documents.files.FileSpecification.Get | ( | Document | context,
|  | string | path,
|  | bool | full |
| ) |  |  | `[static, inherited]`

Creates a new reference to a file.

Parameters:

  | context | Document context.
  | path | File path.
  | full | Whether the reference is able to support extended dependencies.

static SimpleFileSpecification org.pdfclown.documents.files.FileSpecification.Get | ( | Document | context,
|  | string | path |
| ) |  |  | `[static, inherited]`

Creates a new reference to an external file.

Parameters:

  | context | Document context.
  | path | File path.

References org.pdfclown.documents.files.FileSpecification.Get().

Referenced by org.pdfclown.documents.files.FileSpecification.Get().

string org.pdfclown.documents.files.FileSpecification.GetAbsolutePath | ( |  | ) | `[inherited]`

Gets the file absolute path.

static PdfDirectObject org.pdfclown.objects.PdfObjectWrapper.GetBaseObject | ( | PdfObjectWrapper< PdfDirectObject > | wrapper | ) | `[static, inherited]`

Gets the PDF object backing the specified wrapper.

Parameters:

  | wrapper | Object to extract the base from.

override int org.pdfclown.objects.PdfObjectWrapper.GetHashCode | ( |  | ) | `[inherited]`

override bytes::IInputStream org.pdfclown.documents.files.FullFileSpecification.GetInputStream | ( |  | ) | `[virtual]`

Gets an input stream to read from the file.

Reimplemented from org.pdfclown.documents.files.FileSpecification.

override bytes::IOutputStream org.pdfclown.documents.files.FullFileSpecification.GetOutputStream | ( |  | ) | `[virtual]`

Gets an output stream to write into the file.

Reimplemented from org.pdfclown.documents.files.FileSpecification.

virtual PdfString org.pdfclown.objects.PdfObjectWrapper.RetrieveName | ( |  | ) | `[protected, virtual, inherited]`

Retrieves the name possibly associated to this object, walking through the document's name dictionary.

PdfDirectObject org.pdfclown.objects.PdfObjectWrapper.RetrieveNamedBaseObject | ( |  | ) | `[protected, inherited]`

Retrieves the object name, if available; otherwise, behaves like PdfObjectWrapper.BaseObject.

void org.pdfclown.documents.files.FullFileSpecification.SetPath | ( | string | value | ) |

References org.pdfclown.documents.files.FullFileSpecification.SetPath().

Referenced by org.pdfclown.documents.files.FullFileSpecification.SetPath().

static FileSpecification org.pdfclown.documents.files.FileSpecification.Wrap | ( | PdfDirectObject | baseObject | ) | `[static, inherited]`

Instantiates an existing file reference.

Parameters:

  | baseObject | Base object.

References org.pdfclown.objects.PdfObject.Resolve().

## Property Documentation

PdfDirectObject org.pdfclown.objects.IPdfObjectWrapper.BaseObject`[get, inherited]`

Gets the underlying reference object, if available; otherwise, gets the underlying data object.

Implemented in org.pdfclown.objects.PdfObjectWrapper.

Referenced by org.pdfclown.documents.interaction.actions.SetLayerState.LayerStates.Add(), and org.pdfclown.documents.interaction.actions.SetLayerState.LayerStates.Insert().

virtual PdfDirectObject org.pdfclown.objects.PdfObjectWrapper.BaseObject`[get, set, inherited]`

Gets the underlying reference object, if available; otherwise, gets the underlying data object.

PdfIndirectObject org.pdfclown.objects.PdfObjectWrapper.Container`[get, inherited]`

Gets the indirect object containing the base object.

PdfIndirectObject org.pdfclown.objects.PdfObjectWrapper.DataContainer`[get, inherited]`

Gets the indirect object containing the base data object.

RelatedFiles org.pdfclown.documents.files.FullFileSpecification.Dependencies`[get, set]`

Gets/Sets the related files.

string org.pdfclown.documents.files.FullFileSpecification.Description`[get, set]`

Gets/Sets the description of the file.

Document org.pdfclown.objects.PdfObjectWrapper.Document`[get, inherited]`

Gets the document context.

EmbeddedFile org.pdfclown.documents.files.FullFileSpecification.EmbeddedFile`[get, set]`

Gets/Sets the embedded file corresponding to this file.

File org.pdfclown.objects.PdfObjectWrapper.File`[get, inherited]`

Gets the file context.

object org.pdfclown.documents.files.FullFileSpecification.FileSystem`[get, set]`

Gets/Sets the file system to be used to interpret this file specification.

Returns:
  Either StandardFileSystemEnum (standard file system) or String (custom file system).

FileIdentifier org.pdfclown.documents.files.FullFileSpecification.ID`[get, set]`

Gets/Sets the identifier of the file.

PdfString org.pdfclown.documents.files.FileSpecification.Name`[get, inherited]`

Gets the object name.

As names are tipically loosely-coupled with their corresponding PDF objects, name retrieval implies a costly reverse lookup into the document's name tree.

Implements org.pdfclown.objects.IPdfNamedObjectWrapper.

PdfDirectObject org.pdfclown.documents.files.FileSpecification.NamedBaseObject`[get, inherited]`

Gets the object name, if available; otherwise, behaves like BaseObject.

Implements org.pdfclown.objects.IPdfNamedObjectWrapper.

override string org.pdfclown.documents.files.FullFileSpecification.Path`[get]`

Gets the file path.

Reimplemented from org.pdfclown.documents.files.FileSpecification.

bool org.pdfclown.documents.files.FullFileSpecification.Volatile`[get, set]`

Gets/Sets whether the referenced file is volatile (changes frequently with time).

Copyright 2006-2013 Stefano Chizzolini. For more information, please visit PDF Clown home page.